/*
**	File:			Macros.h
**
**	Description:	Some useful macros for use with the SampleFilter code.
**
**	Version:		
**
**	Copyright 1999 Apple Computer. All rights reserved.
**
**	You may incorporate this sample code into your applications without
**	restriction, though the sample code has been provided "AS IS" and the
**	responsibility for its operation is 100% yours.  However, what you are
**	not permitted to do is to redistribute the source as "ABC Sample Code"
**	after having made changes. If you're going to re-distribute the source,
**	we require that you make it clear in the source that the code was
**	descended from Apple Sample Code, but that you've made changes.
**
*/

#define Unused(param)	((void)(param))

/*	The following two macros are intended to make it easier to
	declare routines that will be invoked by the MixedMode Mgr.
	DeclareProcPtr() will create a routine descriptor with the
	name g_'proc' if we are compiling in an environment that
	needs routine descriptors. If we are in the old 68K environment
	then this macro does nothing. MakeProcPtr creates a reference to
	the function pointer 'proc'. If we are using routine descriptors
	then the reference is the address of the descriptor created by
	DeclareProcPtr(). If we are in a 68K world then the reference
	is just the proc pointer itself.
*/
#if TARGET_RT_MAC_CFM

#define DeclareProcPtr(proc, upp)	\
		RoutineDescriptor g_##proc = BUILD_ROUTINE_DESCRIPTOR(upp, proc);
#define ExternalProcPtr(proc)	\
		extern RoutineDescriptor g_##proc;
#define MakeProcPtr(proc, procType)	\
		((procType)&g_##proc)
		
#else

#define DeclareProcPtr(proc, upp)
#define ExternalProcPtr(proc)
#define MakeProcPtr(proc, procType)	\
		((procType)proc)
		
#endif
