#include "AEUserTermTypes.r"
#include "AERegistry.r"
#include "AppleEvents.r"

#include "PrintAETypes.h"

resource kAETerminologyExtension (0) {
	0x1,
	0x0,
	english,
	roman,
	{	/* array Suites: 2 elements */
		/* [1] */
		"Standard Suite",
		"Common terms for most applications",
		'CoRe',
		1,
		1,
		{	/* array Events: 4 elements */
			/* [1] */
			"open",
			"Open the specified object(s)",
			kCoreEventClass,
			kAEOpenDocuments,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			verbEvent,
			reserved,
			reserved,
			reserved,
			cObjectSpecifier,
			"Objects to open. Can be a list of files or an object specifier.",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [2] */
			"print",
			"Print the specified object(s)",
			kCoreEventClass,
			kAEPrintDocuments,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			verbEvent,
			reserved,
			reserved,
			reserved,
			cObjectSpecifier,
			"Objects to print. Can be a list of files or an object specifier.",
			directParamRequired,
			listOfItems,
			notEnumerated,
			doesntChangeState,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			{	/* array OtherParams: 2 elements */
				/* [1] */
				"with properties",
				keyAEPropData,
				kPrintSettingsAEType,
				"the print settings",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				prepositionParam,
				notFeminine,
				notMasculine,
				singular,
				/* [2] */
				"print dialog",
				kPrintDialogAEType,
				typeBoolean,
				"Should the application show the print dialog?",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				prepositionParam,
				notFeminine,
				notMasculine,
				singular
			},
			/* [3] */
			"run",
			"Sent to an application when it is double-clicked",
			kCoreEventClass,
			kAEOpenApplication,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			verbEvent,
			reserved,
			reserved,
			reserved,
			noParams,
			"No direct parameter required",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [4] */
			"quit",
			"Quit application",
			kCoreEventClass,
			kAEQuitApplication,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			verbEvent,
			reserved,
			reserved,
			reserved,
			noParams,
			"No direct parameter required",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			reserved,
			{	/* array OtherParams: 0 elements */
			}
		},
		{	/* array Classes: 1 elements */
			/* [1] */
			"print settings",
			kPrintSettingsAEType,
			"",
				{
				/* [1] */
				kPrCopiesAEProp,
				kPrCopiesAEKey,
				kPrCopieAEType,
				"the number of copies of a document to be printed ",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [2] */
				kPrCollateAEProp,
				kPrCollateAEKey,
				kprCollateAEType,
				"Should printed copies be collated?",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [3] */
				kPrJobCopyAEProp,
				kPrJobCopyAEKey,
				kPrJobCopyAEType,
				"Should a job copy be generated?",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [4] */
				kPrJobLogAEProp,
				kPrJobLogAEKey,
				kPrJobLogAEType,
				"Should a job log be generated?",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [5] */
				kPrJobLogDirAEProp,
				kPrJobLogDirAEKey,
				kPrJobLogDirAEType,
				"the folder in which the job log and copy should be created",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [6] */
				kprFirstPageAEProp,
				kPrFirstPageAEKey,
				kPrFirstPageAEType,
				"the first page of the document to be printed",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [7] */
				kPrLastPageAEProp,
				kPrLastPageAEKey,
				kPrLastPageAEType,
				"the last page of the document to be printed",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [8] */
				kPrLayoutAcrossAEProp,
				kPrLayoutAcrossAEKey,
				kPrLayoutAcrossAEType,
				"number of logical pages laid across a physical page",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [9] */
				kPrLayoutDownAEProp,
				kPrLayoutDownAEKey,
				kPrLatoutDownAEType,
				"number of logical pages laid out down a physical page",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [10] */
				kPrPrintTimeAEProp,
				kPrPrintTimeAEKey,
				kprPrintTimeAEType,
				"the time at which the desktop printer should print the document...",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [11] */
				kPrQueueAEProp,
				kPrQueueAEKey,
				kPrQueueAEType,
				"... or, how the printed document should be placed into the desktop printer queue",
				reserved,
				singleItem,
				enumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				
				/* [12] */
				kPrCoverPageAEProp,
				kPrCoverPageAEKey,
				kPrCoverPageAEType,
				"should a cover page be generated for the job and where should it be placed",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [13] */
				kPrErrorHandlingAEProp,
				kPrErrorHandlingAEKey,
				kPrErrorHandlingAEType,
				"how errors are handled",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,

				/* [14] */
				kPrFeatureAEProp,
				kPrFeatureAEKey,
				kPrFeatureAEType,
				"for printer specific features",
				reserved,
				listOfItems,
				notEnumerated,
				readOnly,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				reserved,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
			},
			{	/* array Elements: 0 elements */
			}
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 3 elements */
			/* [1] */
			kPrQueueAEType,
			{	/* array Enumerators: 4 elements */
				/* [1] */
				"urgent",
				kPrEnumQUrgent,
				"place the job at the front of the queue",
				/* [2] */
				"normal",
				kPrEnumQNormal,
				"place the job at the end of the queue",
				/* [3] */
				"hold",
				kPrEnumQHold,
				"place the job in the queue but put in on hold so that it does not print",
				/* [4] */
				"foreground",
				kPrEnumQForeground,
				"avoid the print queue and print immediately"
			},
			/* [2] */
			kPrCoverPageAEType,
			{	/* array Enumerators: 3 elements */
				/* [1] */
				"none",
				kPrCoverPageNoneEnum,
				"do not generate a cover page",
				/* [2] */
				"cover page before job",
				kPrCoverPageAtStartEnum,
				"generate the cover page at the start of the document",
				/* [3] */
				"cover page after job",
				kPrCoverPageAtEndEnum,
				"generate the cover page at the end of the document"
			},
			/* [3] */
			kPrErrorHandlingAEType,
			{	/* array Enumerators: 3 elements */
				/* [1] */
				"standard",
				kPrErrorHandlingStandardEnum,
				"Standard PostScript error handling  ",
				/* [2] */
				"summarized",
				kPrErrorHandlingSummaryEnum,
				"summarize PostScript errors on screen ",
				/* [3] */
				"detailed",
				kPrErrorHandlingDetailedEnum,
				"print a detailed report of PostScript errors"
			}
		},
		/* [2] */
		"Required Suite",
		"Terms that every application should support",
		kAERequiredSuite,
		1,
		1,
		{	/* array Events: 0 elements */
		},
		{	/* array Classes: 0 elements */
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 0 elements */
		},
	}
};
