/*
**	File:		CoercePrGeneral.h
**
**	Definitions needed to call the kPrCoerceOp PrGeneral call directly
**
** Copyright 1999 Apple Computer. All rights reserved.
**
**	You may incorporate this sample code into your applications without
**	restriction, though the sample code has been provided "AS IS" and the
**	responsibility for its operation is 100% yours. However, what you are
**	not permitted to do is to redistribute the source as "DSC Sample Code"
**	after having made changes. If you're going to re-distribute the source,
**	we require that you make it clear in the source that the code was
**	descended from Apple Sample Code, but that you've made changes.
*/

#ifndef __COERCEPRGENERAL__
#define __COERCEPRGENERAL__

#ifndef __PRINTAETYPES__
#include "PrintAETypes.h"
#endif

#if PRAGMA_ONCE
#pragma once
#endif

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=mac68k
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(push, 2)
#elif PRAGMA_STRUCT_PACK
	#pragma pack(2)
#endif

typedef struct {
	short iOpCode;
	short iError;
	long lReserved;
	const AEDesc *fromDesc;
	DescType toType;
	AEDesc *toDesc;
} PrCoerceStruct;

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=reset
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(pop)
#elif PRAGMA_STRUCT_PACK
	#pragma pack()
#endif

#endif /* __COERCEPRGENERAL__ */