/*
*	File:		PrintAETypes.h
*
*	Contains:	Public interfaces for AppleScripting.
*
*	Copyright:	 1999 by Apple Computer Inc., all rights reserved.
*
*/

#ifndef __PRINTAETYPES__
#define __PRINTAETYPES__


#ifndef rez
	#include "AEDataModel.h"
	#include "AEregistry.h"
	#pragma once
#else
	#include "AEDataModel.r"
	#include "AERegistry.r"
#endif


/*	The Apple Event type for a Print Manager print record - TPrint.
*/
#define kPrintRecordAEType			'prec'
#define kPrintSettingsAEType		'prST'
#define kPrintDialogAEType			'pdlg'

#define kPrCoerceOp					(27)

#define kPrCopiesAEProp					"copies"
#define kPrCopiesAEKey					'lwcp'
#define kPrCopieAEType					typeSInt32

#define kPrCollateAEProp				"collating"
#define kPrCollateAEKey					'lwcl'
#define kPrCollateAEType				typeBoolean

#define kPrJobCopyAEProp				"generating job copy"
#define kPrJobCopyAEKey					'lwjc'
#define kPrJobCopyAEType				typeBoolean

#define kPrJobLogAEProp					"generating job log"
#define kPrJobLogAEKey					'lwjl'
#define kPrJobLogAEType					typeBoolean

#define kPrJobLogDirAEProp				"log folder"
#define kPrJobLogDirAEKey				'lwjd'
#define kPrJobLogDirAEType				typeAlias		

#define kprFirstPageAEProp				"starting page"
#define kPrFirstPageAEKey				'lwfp'
#define kPrFirstPageAEType				typeSInt32

#define kPrLastPageAEProp				"ending page"
#define kPrLastPageAEKey				'lwlp'
#define kPrLastPageAEType				typeSInt32

#define kPrLayoutAcrossAEProp			"pages across"
#define kPrLayoutAcrossAEKey			'lwla'
#define kPrLayoutAcrossAEType			typeSInt32

#define kPrLayoutDownAEProp				"pages down"
#define kPrLayoutDownAEKey				'lwld'
#define kPrLatoutDownAEType				typeSInt32

#define kPrErrorHandlingAEProp			"error handling"
#define kPrErrorHandlingAEKey			'lweh'
#define kPrErrorHandlingAEType			'lwee'

#define kPrCoverPageAEProp				"cover page"
#define kPrCoverPageAEKey				'lwcv'
#define kPrCoverPageAEType				'lwec'

#define kPrQueueAEProp					"queue placement"
#define kPrQueueAEKey					'lwqu'
#define kPrQueueAEType					'lwqe'	

#define kPrPrintTimeAEProp				"requested print time"
#define kPrPrintTimeAEKey				'lwqt'
#define kPrPrintTimeAEType				cLongDateTime

#define kPrOutProfileAEProp				"profile"
#define kPrOutProfileAEKey				'lwop'
#define kPrOutProfileAEType				typeFSS

#define kPrColorMatchingAEProp			"color matching"
#define kPrColorMatchingAEKey			'lwcm'
#define kPrColorMatchingAEType			typeBoolean

#define kPrFeatureAEProp				"printer features"
#define kPrFeatureAEKey					'lwpf'
#define kPrFeatureAEType				typeAEList

/*** Enumerations ***/

/* For kPrQueueStateAEType */

#define kPrEnumQNormal						'lwqn'
#define kPrEnumQUrgent						'lwqq'
#define kPrEnumQHold						'lwqh'
#define kPrEnumQForeground					'lwqf'

/* For kPrCoverPageAEType */

#define kPrCoverPageNoneEnum				'lwno'
#define kPrCoverPageAtStartEnum				'lwas'
#define kPrCoverPageAtEndEnum				'lwae'

/* For kPrErrorHandlingAEType */
#define kPrErrorHandlingStandardEnum		'lwst'
#define kPrErrorHandlingSummaryEnum			'lwsm'
#define kPrErrorHandlingDetailedEnum		'lwdt'


#endif		// __PRINTAETYPES__
