/*
** Copyright 1991-1996 Apple Computer. All rights reserved.
**
**	You may incorporate this sample code into your applications without
**	restriction, though the sample code has been provided "AS IS" and the
**	responsibility for its operation is 100% yours.  However, what you are
**	not permitted to do is to redistribute the source as "DSC Sample Code"
**	after having made changes. If you're going to re-distribute the source,
**	we require that you make it clear in the source that the code was
**	descended from Apple Sample Code, but that you've made changes.
*/

/* Note: For dialogs and alerts, we have 'dctb's and 'actb's around, even
** though they're not strictly needed. This is so that anyone who adds to
** our dialogs (or alerts, though I can't figure how they'd do that) gets
** a color dialog to play with, and they can have happy colorful icons.
**
** Defining SystemSevenOrLater allows me to use the auto-magic dialog
** positioning and not have to write code to do that. If you're supporting
** system 6, you'll need to fill in the DialogPosition function in the
** MyPDEF_4_HandlingDialogs.c file.
*/

#define SystemSevenOrLater 1

#include "Types.r"
#include "Systypes.r"
#include "BalloonTypes.r"

#ifndef VER_SHORT
#define VER_SHORT 0x211
#endif

#ifndef VER_STRING
#define VER_STRING "2.1.1"
#endif

#define IDENT "StdFileSaver "VER_STRING", Copyright 1996, Apple Computer Inc."

/* I've registered the following wDev (185 decimal) for this driver. -DaveP */
#define WDEV 0xb900

#include "MyPrintTypes.r"


resource 'PREC' (1) {
	1, 0, 72, 72, {0, 0, 781, 538}, {0, 0, 781, 538}, WDEV, 1302, 897, 0,
	feedMechCut, 0, 72, 72, {0, 0, 781, 538}, 1, 0, 100, 0, 1, 0, 1, 1, 1,
	scanTB, 2, 1, 9999, 1, 0, 0, 0x0, 0x0, 0, 0, 0,
	{	/* array: 19 elements */
		1, 0, 538, 781, 2, 0, 0, 0x5345, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	}
};

resource 'PREC' (0) {
	1, 0, 72, 72, {0, 0, 781, 538}, {0, 0, 781, 538}, WDEV, 1302, 897, 0,
	feedMechCut, 0, 72, 72, {0, 0, 781, 538}, 1, 0, 100, 0, 1, 0, 1, 1, 1,
	scanTB, 2, 1, 9999, 1, 0, 0, 0x0, 0x0, 0, 0, 0,
	{	/* array: 19 elements */
		1, 0, 538, 781, 2, 0, 0, 0x5345, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	}
};

resource 'hfdr' (-5696) {
	2, 0, 0, 0, { HMTEResItem { -4079 } }
};

data 'styl' (-4079) {
	$"0001 0000 0000 000D 000A 0004 0077 000A"            /* ............w.. */
	$"0000 0000 0000"                                     /* ...... */
};

data 'TEXT' (-4079, "Product Description") {
	$"4120 7361 6D70 6C65 2070 7269 6E74 2064"            /* A sample print d */
	$"7269 7665 7220 7768 6963 6820 7072 696E"            /* river which prin */
	$"7473 2074 6F20 6120 2750 4943 5427 2072"            /* ts to a 'PICT' r */
	$"6573 6F75 7263 65"                                  /* esource */
};

resource 'STR ' (-8191) {
	"PictFile"
};

resource 'STR ' (-8190) {
	"Select output file"
};

resource 'ALRT' (-8160, purgeable) {
	{32, 30, 110, 482}, -8160,
	{	/* array: 4 elements */
		/* [1] */ OK, visible, sound1,
		/* [2] */ OK, visible, sound1,
		/* [3] */ OK, visible, sound1,
		/* [4] */ OK, visible, sound1
	},
	alertPositionMainScreen
};

resource 'DITL' (-8160, purgeable) {
	{	/* array DITLarray: 2 elements */
		/* [1] */ {4, 380, 22, 440}, Button { enabled, "OK" },
		/* [2] */ {3, 80, 68, 373}, StaticText { disabled,
			"The typed values are either too big or too small.\nCorrect them, please."
		}
	}
};

resource 'actb' (-8160) {
	{	/* array ColorSpec: 5 elements */
		/* [1] */	wContentColor, 65535, 65535, 65535,
		/* [2] */	wFrameColor, 0, 0, 0,
		/* [3] */	wTextColor, 0, 0, 0,
		/* [4] */	wHiliteColor, 0, 0, 0,
		/* [5] */	wTitleBarColor, 65535, 65535, 65535
	}
};

resource 'DLOG' (-8191) {
	{50, 10, 154, 502}, dBoxProc, invisible, noGoAway, 0x1, -8191, "Job",
	alertPositionMainScreen
};

resource 'DITL' (-8191) {
	{	/* array DITLarray: 15 elements */
		/* [1] */ {4, 420, 24, 480}, Button { enabled, "OK" },
		/* [2] */ {31, 420, 50, 480}, Button { enabled, "Cancel" },
		/* [3] */ {4, 4, 20, 412}, StaticText { disabled, IDENT },
		/* [4] */ {40, 4, 56, 88}, StaticText { disabled, "Page Range:" },
		/* [5] */ {40, 100, 56, 188}, RadioButton { enabled, "All" },
		/* [6] */ {40, 200, 56, 260}, RadioButton { enabled, "From:" },
		/* [7] */ {40, 264, 56, 296}, EditText { enabled, "" },
		/* [8] */ {40, 304, 56, 332}, StaticText { disabled, "To:" },
		/* [9] */ {40, 332, 56, 364}, EditText { enabled, "" },
		/* [10] */ {22, 4, 23, 412}, Button { disabled, "" },
		/* [11] */ {24, 4, 25, 412}, Button { disabled, "" },
		/* [14] */ {64, 100, 80, 250}, RadioButton { enabled, "Color" },
		/* [15] */ {80, 100, 96, 250}, RadioButton { enabled, "Black & White" }
		}
};

resource 'dctb' (-8191) {
	{	/* array ColorSpec: 5 elements */
		/* [1] */	wContentColor, 65535, 65535, 65535,
		/* [2] */	wFrameColor, 0, 0, 0,
		/* [3] */	wTextColor, 0, 0, 0,
		/* [4] */	wHiliteColor, 0, 0, 0,
		/* [5] */	wTitleBarColor, 65535, 65535, 65535
	}
};

resource 'DLOG' (-8192) {
	{30, 10, 174, 502}, dBoxProc, invisible, noGoAway, 0x1, -8192, "Stl",
	alertPositionMainScreen
};

resource 'DITL' (-8192) {
	{	/* array DITLarray: 21 elements */
		/* [1] */	{4, 420, 24, 480},	Button { enabled, "OK" },
		/* [2] */	{31, 420, 50, 480},	Button { enabled, "Cancel" },
		/* [3] */	{4, 4, 20, 412},		StaticText { disabled, IDENT },
		/* [4] */	{72, 3, 88, 81},		StaticText { disabled, "Orientation" },
		/* [5] */	{32, 3, 48, 50},		StaticText { disabled, "Paper:" },
		/* [6] */	{32, 52, 48, 152},	RadioButton { enabled, "A4" },
		/* [7] */	{48, 52, 64, 152},	RadioButton { enabled, "US letter" },
		/* [8] */	{32, 156, 48, 256},	RadioButton { enabled, "Custom" },
		/* [9] */	{91, 7, 123, 39},		Icon { enabled, -8192 },
		/* [10] */	{91, 46, 123, 78},	Icon { enabled, -8191 },
		/* [11] */	{22, 4, 23, 412},		Button { disabled, "" },
		/* [12] */	{24, 4, 25, 412},		Button { disabled, "" },
		/* [13] */	{72, 184, 88, 232},	StaticText { disabled, "Horiz." },
		/* [14] */	{72, 296, 88, 336},	StaticText { disabled, "Vert." },
		/* [15] */	{96, 184, 112, 232},	StaticText { disabled, "Unit" },
		/* [16] */	{72, 232, 88, 288},	EditText { enabled, "" },
		/* [17] */	{72, 336, 88, 392},	EditText { enabled, "" },
		/* [18] */	{96, 232, 112, 328},	RadioButton { enabled, "MilliInches" },
		/* [19] */	{112, 232, 128, 328},	RadioButton { enabled, "MilliMeters" },
		/* [20] */	{96, 336, 112, 416},	RadioButton { enabled, "Pixels" },
		/* [21] */	{55, 420, 74, 480},	Button { enabled, "Help" }
	}
};

resource 'dctb' (-8192) {
	{	/* array ColorSpec: 5 elements */
		/* [1] */	wContentColor, 65535, 65535, 65535,
		/* [2] */	wFrameColor, 0, 0, 0,
		/* [3] */	wTextColor, 0, 0, 0,
		/* [4] */	wHiliteColor, 0, 0, 0,
		/* [5] */	wTitleBarColor, 65535, 65535, 65535
	}
};

resource 'DLOG' (-8194) {
	{32, 10, 332, 502}, dBoxProc, visible, noGoAway, 0x0, -8194, "Help",
	alertPositionMainScreen
};

resource 'DITL' (-8194) {
	{	/* array DITLarray: 10 elements */
		/* [1] */ {4, 420, 24, 480}, Button { enabled, "OK" },
		/* [2] */ {4, 4, 20, 412}, StaticText { disabled, IDENT },
		/* [3] */ {22, 4, 23, 412}, Button { disabled, "" },
		/* [4] */ {24, 4, 25, 412}, Button { disabled, "" },
		/* [5] */ {40, 16, 72, 48}, Icon { disabled, 1 },
		/* [6] */ {40, 56, 80, 412}, StaticText { disabled,
			"This driver saves all the graphic output, that would have been printed,"
			" in PICT resources within a file. The PICT generated can be in"
			" color or in black and white."
			},
		/* [7] */ {80, 56, 120, 412}, StaticText { disabled,
			"You can choose any page size format in either Pixels, MilliMeters or MilliInches."
			},
		/* [8] */ {120, 56, 160, 412}, StaticText { disabled, ""
			},
		/* [9] */ {160, 56, 200, 412}, StaticText { disabled, ""
			},
		/* [10] */ {200, 56, 256, 440}, StaticText { disabled, ""
			},
		/* [11] */ {256, 56, 296, 412}, StaticText { disabled,
			"This driver is free and should always be given with its sources."
			"\nIt was MPW C and MPW Asm (just a few lines) and compiles with SC as well."
			"\nThanks to Scott \"ZZ\" Zimmerman for his help, and Eric Simenel "
			"for doing the Pascal version."
			}
		}
};

resource 'dctb' (-8194) {
	{	/* array ColorSpec: 5 elements */
		/* [1] */	wContentColor, 65535, 65535, 65535,
		/* [2] */	wFrameColor, 0, 0, 0,
		/* [3] */	wTextColor, 0, 0, 0,
		/* [4] */	wHiliteColor, 0, 0, 0,
		/* [5] */	wTitleBarColor, 65535, 65535, 65535
	}
};

data 'TMPL' (-4080, "SFpf", purgeable) {		/* Resorcerer template */
	$"1853 656C 6563 7465 6420 4974 656D 2069"            /* .Selected Item i */
	$"6E20 4368 6F6F 7365 7244 5752 4412 5361"            /* n ChooserDWRD.Sa */
	$"7665 2050 6963 7420 5265 736F 7572 6365"            /* ve Pict Resource */
	$"424F 4F4C"                                          /* BOOL */
};

data 'SFpf' (-4080) {	/* default preferences. Pretty boring */
	$"0000 0000"
};

resource 'ICON' (-8191) {
	$"FFFF FFFF 8000 0001 8000 0001 803F FF81"
	$"8420 00C1 8E20 00A1 9F20 0091 BFA0 00F9"
	$"8E20 0009 8E20 0009 8E20 0009 8E2F F009"
	$"8E28 0809 8E3F 8809 8E20 0B89 8E20 0449"
	$"8E20 0049 8E20 0449 8020 0B89 8A3F 8809"
	$"8028 0809 8A2F F009 8020 0009 8A20 0009"
	$"8020 0009 8A20 0009 8020 0009 8020 0009"
	$"803F FFF9 8000 0001 8000 0001 FFFF FFFF"
};

resource 'ICON' (-8192) {
	$"FFFF FFFF 8000 0001 8000 0001 803F FF81"
	$"8420 00C1 8E20 38A1 9F20 4491 BFA0 44F9"
	$"8E20 4409 8E20 2809 8E21 C709 8E22 0089"
	$"8E22 0089 8E22 0089 8E22 8289 8E22 8289"
	$"8E22 8289 8E22 8289 8022 8289 8A23 BB89"
	$"8020 AA09 8A20 AA09 8020 AA09 8A20 AA09"
	$"8020 AA09 8A20 AA09 8020 EE09 8020 0009"
	$"803F FFF9 8000 0001 8000 0001 FFFF FFFF"
};

resource 'icl4' (128) {
	$"0000 00FF FFFF FFFF FFFF 0000 0000 0000 0000 00FC CCCC CCCC"
	$"CCCF F000 0000 0000 0000 00FC FFFF FFFC CCCF CF00 0000 0000"
	$"0000 00FC F222 22FC CCCF CCF0 0000 0000 0000 00FC F222 22FC"
	$"CCCF CCCF 0000 0000 0000 00FC F222 22FF FFCF FFFF F000 0000"
	$"0000 00FC F222 22F8 8FCC CCCC F000 0000 0000 00FC FFFF FFF8"
	$"8FCC CCCC F000 0000 0000 00FC CCFD F888 8FCC CCCC F000 0000"
	$"0000 00FC CFDD F888 8FCC CCCC F000 0000 0000 00FC CFDD FFFF"
	$"FFCC CCCC F000 0000 0000 00FC CFDD DDDF CCCC CCCC F000 0000"
	$"0000 00FC CCFD DDFC CCCC CCCC F000 0000 0000 00FC CCCF FFCC"
	$"CCCC CCCC F000 0000 0000 00FC CCCC CCCC CCCC CCCC F000 0000"
	$"0000 00FC CFFF CFCF FFCF FFCC F000 0000 0000 00FC CFCF CFCF"
	$"CCCC FCCC F000 0000 0000 00FC CFFF CFCF CCCC FCCC F000 0000"
	$"0000 00FC CFCC CFCF FFCC FCCC F000 0000 0000 00FC CCCC CCCC"
	$"CCCC CCCC F000 0000 0000 FFFF FFFF FFFF FFFF FFFF FFFF 0000"
	$"FFFF FCCC CCCC CCCC CCCC CCCC CCCF FFFE FCCC FEEE EEEE EEEE"
	$"EEEE EEEE EEEF CFEF FEEE FCCC CCCC CCCC CCCC CCCC CCCF EF0F"
	$"FCCC FCCC CCCC CCCC CCCC CCCC CCCF CFCF FC88 FFFF FFFF FFFF"
	$"FFFF FFFF FFFF CFDF FC33 CCCC CCCC CCCC CCCC CCCC CCCC CFEF"
	$"FCCC CCCC CCCC CCCC CCCC CCCC CCCC CFFE FDED EDED EDED EDED"
	$"EDED EDED EDED EF00 FCEC ECEC ECEC ECEC ECEC ECEC ECEC EF00"
	$"EFFF FFFF FFFF FFFF FFFF FFFF FFFF FE"
};

resource 'icl8' (128) {
	$"0000 0000 0000 FFFF FFFF FFFF FFFF FFFF FFFF FFFF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6FF FF00 0000 0000 0000 0000 0000 0000 0000 0000 FFF6"
	$"FFFF FFFF FFFF FFF6 F6F6 F6FF 2BFF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FFF6 FF16 1616 1616 FFF6 F6F6 F6FF 2B2B FF00"
	$"0000 0000 0000 0000 0000 0000 0000 FFF6 FF16 1616 1616 FFF6"
	$"F6F6 F6FF 2B2B 2BFF 0000 0000 0000 0000 0000 0000 0000 FFF6"
	$"FF16 1616 1616 FFFF FFFF F6FF FFFF FFFF FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 FF16 1616 1616 FFE3 E3FF F6F6 F6F6 F6F6"
	$"FF00 0000 0000 0000 0000 0000 0000 FFF6 FFFF FFFF FFFF FFE3"
	$"E3FF F6F6 F6F6 F6F6 FF00 0000 0000 0000 0000 0000 0000 FFF6"
	$"F6F6 FF33 FFE3 E3E3 E3FF F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6FF 3333 FFE3 E3E3 E3FF F6F6 F6F6 F6F6"
	$"FF00 0000 0000 0000 0000 0000 0000 FFF6 F6FF 3333 FFFF FFFF"
	$"FFFF F6F6 F6F6 F6F6 FF00 0000 0000 0000 0000 0000 0000 FFF6"
	$"F6FF 3333 3333 33FF F6F6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 FF33 3333 FFF6 F6F6 F6F6 F6F6 F6F6"
	$"FF00 0000 0000 0000 0000 0000 0000 FFF6 F6F6 F6FF FFFF F6F6"
	$"F6F6 F6F6 F6F6 F6F6 FF00 0000 0000 0000 0000 0000 0000 FFF6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6FF FFFF F6FF F6FF FFFF F6FF FFFF F6F6"
	$"FF00 0000 0000 0000 0000 0000 0000 FFF6 F6FF F6FF F6FF F6FF"
	$"F6F6 F6F6 FFF6 F6F6 FF00 0000 0000 0000 0000 0000 0000 FFF6"
	$"F6FF FFFF F6FF F6FF F6F6 F6F6 FFF6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6FF F6F6 F6FF F6FF FFFF F6F6 FFF6 F6F6"
	$"FF00 0000 0000 0000 0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 FF00 0000 0000 0000 0000 0000 FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF 0000 0000"
	$"FFFF FFFF FF2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2BFF FFFF FFFC FF2B 2B2B FFFC FCFC FCFC FCFC FCFC FCFC"
	$"FCFC FCFC FCFC FCFC FCFC FCFF 2BFF FCFF FFFC FCFC FF2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2BFF FCFF F5FF"
	$"FF2B 2B2B FF2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2BFF 2BFF 2BFF FF2B E3E3 FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF 2BFF FAFF FF2B D8D8 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2BFF FCFF"
	$"FF2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2BFF FFFC FFF9 FCF9 FCF9 FCF9 FCF9 FCF9 FCF9 FCF9"
	$"FCF9 FCF9 FCF9 FCF9 FCF9 FCF9 FCFF 0000 FFF8 FBF8 FBF8 FBF8"
	$"FBF8 FBF8 FBF8 FBF8 FBF8 FBF8 FBF8 FBF8 FBF8 FBF8 FBFF 0000"
	$"FCFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFC"
};

resource 'icm#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"3F00 2180 25C0 2C40 2840 2040 2040 FFF0 C030 FFF0 8030 FFE0",
		/* [2] */
		$"3F00 3F80 3FC0 3FC0 3FC0 3FC0 3FC0 FFF0 FFF0 FFF0 FFF0 FFE0"
	}
};

resource 'icm4' (128) {
	$"00FF FFFF 0000 0000 00F0 200F F000 0000 00F0 280F FF00 0000"
	$"00F0 8800 0F00 0000 00F0 B000 0F00 0000 00F0 0000 0F00 0000"
	$"00F0 0000 0F00 0000 FFFF FFFF FFFF 0000 FFCC CCCC CCFF 0000"
	$"FFFF FFFF FFFF 0000 FCCC CCCC CCFF 0000 FFFF FFFF FFF0"
};

resource 'icm8' (128) {
	$"0000 FFFF FFFF FFFF 0000 0000 0000 0000 0000 FF00 1700 00FF"
	$"FF00 0000 0000 0000 0000 FF00 17E3 00FF FFFF 0000 0000 0000"
	$"0000 FF00 E3E3 0000 00FF 0000 0000 0000 0000 FF00 5E00 0000"
	$"00FF 0000 0000 0000 0000 FF00 0000 0000 00FF 0000 0000 0000"
	$"0000 FF00 0000 0000 00FF 0000 0000 0000 FFFF FFFF FFFF FFFF"
	$"FFFF FFFF 0000 0000 FFFF 2B2B 2B2B 2B2B 2B2B FFFF 0000 0000"
	$"FFFF FFFF FFFF FFFF FFFF FFFF 0000 0000 FFF6 F6F6 F6F6 F6F6"
	$"F6F6 FFFF 0000 0000 FFFF FFFF FFFF FFFF FFFF FF"
};

resource 'ICN#' (128, "PRER ICON") {
	{	/* array: 2 elements */
		/* [1] */
		$"03FF F000 0200 1800 02FE 1400 0282 1200 0282 1100 0283 DF80"
		$"0283 C080 02FF C080 022F C080 024F C080 024F C080 0241 0080"
		$"0222 0080 021C 0080 0200 0080 0275 DC80 0255 0880 0275 0880"
		$"0245 C880 0200 0080 0FFF FFF0 F800 001F 8FFF FFF7 F800 001D"
		$"8800 0015 BFFF FFF7 B000 0007 8000 0007 AAAA AAAC AAAA AAAC"
		$"FFFF FFFC",
		/* [2] */
		$"03FF F000 03FF F800 03FF FC00 03FF FE00 03FF FF00 03FF FF80"
		$"03FF FF80 03FF FF80 03FF FF80 03FF FF80 03FF FF80 03FF FF80"
		$"03FF FF80 03FF FF80 03FF FF80 03FF FF80 03FF FF80 03FF FF80"
		$"03FF FF80 03FF FF80 0FFF FFF0 FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFC FFFF FFFC"
		$"FFFF FFFC"
	}
};

resource 'ics#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"1FC0 1060 1050 1178 1708 1608 1008 1008 1008 1008 FFFF A007"
		$"FFFF C003 FFFE FFFE",
		/* [2] */
		$"1FC0 1FE0 1FF0 1FF8 1FF8 1FF8 1FF8 1FF8 1FF8 1FF8 FFFF FFFF"
		$"FFFF FFFF FFFE FFFE"
	}
};

resource 'ics4' (128) {
	$"000F FFFF FF00 0000 000F 0000 0FF0 0000 000F 0220 0F0F 0000"
	$"000F 0228 0FFF F000 000F 0B88 0000 F000 000F 0BB0 0000 F000"
	$"000F 0000 0000 F000 000F 0000 0000 F000 000F 0000 0000 F000"
	$"000F 0000 0000 F000 FFFF FFFF FFFF FFFF FCFC CCCC CCCC CFFF"
	$"F8FF FFFF FFFF FFFF F3CC CCCC CCCC CCFF FEEE EEEE EEEE EEF0"
	$"FFFF FFFF FFFF FFF0"
};

resource 'ics8' (128) {
	$"0000 00FF FFFF FFFF FFFF 0000 0000 0000 0000 00FF 0000 0000"
	$"00FF FF00 0000 0000 0000 00FF 0017 1700 00FF 00FF 0000 0000"
	$"0000 00FF 0017 17E3 00FF FFFF FF00 0000 0000 00FF 005E E3E3"
	$"0000 0000 FF00 0000 0000 00FF 005E 5E00 0000 0000 FF00 0000"
	$"0000 00FF 0000 0000 0000 0000 FF00 0000 0000 00FF 0000 0000"
	$"0000 0000 FF00 0000 0000 00FF 0000 0000 0000 0000 FF00 0000"
	$"0000 00FF 0000 0000 0000 0000 FF00 0000 FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FF2B FF2B 2B2B 2B2B 2B2B 2B2B 2BFF FFFF"
	$"FFE3 FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFD8 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B FFFF FFFC FCFC FCFC FCFC FCFC FCFC FCFC FF00"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FF"
};

resource 'BNDL' (128) {
	CREATOR,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		}
	}
};

resource 'FREF' (128) {
	'PRER',
	0,
	""
};

type CREATOR as 'STR ';

resource CREATOR (0, "Copyright") {
	" 1996, Apple Computer Inc."
};

resource 'vers' (2, purgeable) {
	(VER_SHORT / 256),
	(VER_SHORT & 256),
	release,
	0x0,
	verUs,
	VER_STRING,
	"PictDriver"
};

resource 'vers' (1) {
	(VER_SHORT / 256),
	(VER_SHORT & 256),
	release,
	0x0,
	verUs,
	VER_STRING,
	IDENT
};
